/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __RESONATOR
#define __RESONATOR

#include <multi_curve.h>
#include <solver.h>
#include <iostream>
using namespace std;

struct resonator {

  multi_curve strength; // resonator strength across the entire tone range
  solver get_strength; // solver for resonator strength

  multi_curve left, right; // stereo response of resonator to driver input

  multi_curve wave; // resonator waveform
  solver get_wave; // solver for resonator waveform

  enum {STRENGTH=0xf000, WAVE=0x0f00, LEFT=0x00f0, RIGHT=0x000f}; // possible edits
  unsigned int edited; // what was edited? strength/response/wave

  bool disabled; // is disabled?

  resonator () {
    edited = 0;
    disabled = false;
  }

};

#endif
